//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 clrDeepSkyBlue
#property indicator_color2 clrSandyBrown
#property indicator_color3 clrSandyBrown
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property strict
//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT; // Time frame
extern int                ZlPeriod        = 27;             // "Zero lag" period
extern ENUM_APPLIED_PRICE ZlPrice         = PRICE_CLOSE;    // "Zero lag" price to use
extern ENUM_MA_METHOD     ZlMaMethod      = MODE_EMA;       // Ma metod to use to construct "zero lag"
extern bool               AlertsOn        = false;          // Turn alerts on?
extern bool               AlertsOnCurrent = true;           // Alerts on current (still opened) bar?
extern bool               AlertsMessage   = true;           // Alerts should display message?
extern bool               AlertsSound     = false;          // Alerts should play alert sound?
extern bool               AlertsEmail     = false;          // Alerts should send email?
extern bool               Interpolate     = true;           // Interpolate in multi time frame mode

//
//
//
//
//

double hma[];
double hmaDa[];
double hmaDb[];
double trend[];
double first[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,hma);
   SetIndexBuffer(1,hmaDa);
   SetIndexBuffer(2,hmaDb);
   SetIndexBuffer(3,trend);
   SetIndexBuffer(4,first);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99; 
         TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" zro lag experiment ("+(string)ZlPeriod+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { hma[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == _Period)
   {
      if (trend[limit]==-1) CleanPoint(limit,hmaDa,hmaDb);
      for(int i=limit; i>=0; i--) first[i] = iMA(NULL,0,ZlPeriod,0,ZlMaMethod,ZlPrice,i);
      for(int i=limit; i>=0; i--) 
      {
         double second = iMAOnArray(first,0,ZlPeriod,0,ZlMaMethod,i);
         hma[i]   = 2.0*first[i]-second;
         hmaDa[i] = EMPTY_VALUE;
         hmaDb[i] = EMPTY_VALUE;
         if (i<(Bars-1))
         {
            trend[i] = trend[i+1];
               if (hma[i]>hma[i+1]) trend[i] =  1;
               if (hma[i]<hma[i+1]) trend[i] = -1;
               if (trend[i]==-1) PlotPoint(i,hmaDa,hmaDb,hma);
         }               
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
   if (trend[limit]==-1) CleanPoint(limit,hmaDa,hmaDb);
   for (int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         hma[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ZlPeriod,ZlPrice,ZlMaMethod,AlertsOn,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,0,y);
         trend[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ZlPeriod,ZlPrice,ZlMaMethod,AlertsOn,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,3,y);
         hmaDa[i] = EMPTY_VALUE;
         hmaDb[i] = EMPTY_VALUE;

               if (!Interpolate ||  (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

               //
               //
               //
               //
               //
      
               int n,k; datetime time = iTime(NULL,TimeFrame,y);
                  for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                  for(k = 1; k<n && (i+k)<Bars && (i+n)<Bars; k++)
                  hma[i+k] = hma[i] + (hma[i+n] - hma[i])*k/n;
   }
   for (int i=limit;i>=0;i--) if (trend[i]==-1) PlotPoint(i,hmaDa,hmaDb,hma);
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (AlertsOn)
   {
      int whichBar = 1; if (AlertsOnCurrent) whichBar = 0;
      if (trend[whichBar]!= trend[whichBar+1])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (trend[whichBar] ==  1) doAlert(time1,mess1," zero lag trend changed to up");
            if (trend[whichBar] == -1) doAlert(time1,mess1," zero lag trend changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(Symbol()+" zero lag experiment",message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}